// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

#include <stdint.h>

#ifdef _MSC_VER
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT __attribute__((visibility("default")))
#endif

struct DotNetRuntimeContractDescriptor
{
    uint64_t magic;
    uint32_t flags;
    const uint32_t descriptor_size;
    const char *descriptor;
    const uint32_t pointer_data_count;
    uint32_t pad0;
    const uintptr_t *pointer_data;
};

extern const uintptr_t contractDescriptorPointerData[];

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor;

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor = {
    .magic = 0x0043414443434e44ull, // "DNCCDAC\0"
    .flags = 0x00000001,
    .descriptor_size = 353,
    .descriptor = "{\"version\":0,\"baseline\":\"empty\",\"types\":{\"Thread\":{\"GCHandle\":[392,\"GCHandle\"],\"LinkNext\":[200,\"pointer\"]},\"ThreadStore\":{\"ThreadCount\":184,\"ThreadList\":160},\"GCHandle\":{\"!\":8}},\"globals\":{\"FeatureEHFunclets\":[\"0x1\",\"uint8\"],\"SOSBreakingChangeVersion\":[\"0x4\",\"uint8\"],\"ThreadStore\":[[1],\"pointer\"]},\"contracts\":{\"Thread\":1,\"SOSBreakingChangeVersion\":1}}",
    .pointer_data_count = 2,
    .pointer_data = &contractDescriptorPointerData[0],
};
